// FetAddClient.java
//  Dean Brock <brock@cs.unca.edu>

import java.rmi.* ;
import edu.unca.cs.csci363.brock.fetadd.* ;

public class FetAddClient
{
  private static final int MYPORT = 20000 + 295 ;
  private static final String MYNAME = "BrockFetAdd" ;
    
  private static void testCreate(String Variable, FetAdd fa)
  {
    System.out.println("Calling create with " + Variable) ;
    try {
      fa.create(Variable) ;
      System.out.println("Result: Success!") ;
    } catch (RemoteException re) {
      System.out.println("Result: Failure -- remote exception: " + re) ;
    } catch (VariableAlreadyDefined vae) {
      System.out.println("Result: Failure -- variable already defined") ;
    } catch (ImproperVariable iv) {
      System.out.println("Result: Failure -- improper variable: " + iv) ;
    }
  }

  private static void testIncrement(String Variable, int incrment, FetAdd fa)
  {
    System.out.println("Calling incrment with \"" + 
                       Variable + "\" and " + incrment) ;
    try {
      int res = fa.increment(Variable, incrment) ;
      System.out.println("Result: Success -> " + res + "!") ;
    } catch (RemoteException re) {
      System.out.println("Result: Failure -- remote exception: " + re) ;
    } catch (UndefinedVariable vae) {
      System.out.println("Result: Failure -- variable not defined") ;
    } catch (ImproperVariable iv) {
      System.out.println("Result: Failure -- improper variable: " + iv) ;
    }
  }

  public static void main( String args[] )
  {
    String hostname = "candler.cs.unca.edu" ;
    if (args.length > 0)
      hostname = args[0] ;
    String URLname = "rmi://" + hostname + ":" + MYPORT + "/" + MYNAME ;

    FetAdd fa ;

    // if (System.getSecurityManager() == null)
    //   System.setSecurityManager ( new RMISecurityManager()) ;

    try {
      fa = (FetAdd)Naming.lookup(URLname);
    } catch (Throwable e) {
      System.err.println("exception connecting to " + URLname + ": " + e);
      System.exit(1);
      return ;
    }
    testCreate("abcd", fa) ;
    testCreate("abcde", fa) ;
    testIncrement("abcd", 100, fa) ;

  }
}
