import java.rmi.* ;
import java.rmi.server.* ;
import java.io.* ;
import java.net.* ;

class rmiLookup {

  private static void printRemoteObject(String s){
    String ParseMe = s ;
    String className = "" ;
    String obJect = "" ;
    String endPoint = "" ;
    int lo, hi ;
    boolean printLong = false ;

    lo = ParseMe.indexOf((int) '[') ;
    hi = ParseMe.length() ;
    if (lo != -1 && ParseMe.charAt(hi-1) == ']') {
      className = ParseMe.substring(0, lo) ;
      ParseMe = ParseMe.substring(lo+1, hi-1) ;
      lo = ParseMe.indexOf((int) '[') ;
      hi = ParseMe.length() ;
      if (lo != -1 && ParseMe.charAt(hi-1) == ']' &&
	  ParseMe.startsWith("RemoteStub")) {
	ParseMe = ParseMe.substring(lo+1, hi-1) ;
	lo = ParseMe.indexOf((int) '[') ;
	hi = ParseMe.length() ;
	if (lo != -1 && ParseMe.charAt(hi-1) == ']' &&
	    ParseMe.startsWith("ref:")) {
	  ParseMe = ParseMe.substring(lo+1, hi-1) ;
	  if (ParseMe.startsWith("endpoint:")) {
	    lo = ParseMe.indexOf((int) '[') ;
	    hi = ParseMe.indexOf((int) ']') ;
	    if (lo != -1 && lo < hi) {
	      endPoint = ParseMe.substring(lo+1, hi) ;
	      if (endPoint.indexOf((int) '[') == -1) {
		ParseMe = ParseMe.substring(hi+1) ;
		ParseMe = ParseMe.substring(ParseMe.indexOf((int)',')+1);
		lo = ParseMe.indexOf((int) '[') ;
		hi = ParseMe.indexOf((int) ']') ;
		obJect = ParseMe.substring(lo+1, hi) ;
		if (obJect.indexOf((int) '[') == -1)
		  printLong = true ;
	      }
	    }
	  }
	}
      }
    }
    if (printLong) {
      System.out.println("   " + className) ;
      System.out.println("   " + endPoint) ;
      System.out.println("   " + obJect) ;
    }
    else
      System.out.println("  " + s) ;
  }


  public static void main (String args[]) {
  
    String RemoteHost  = "candler.cs.unca.edu" ;
    if (args.length > 0)
       RemoteHost = args[0] ;

    String RemoteURL = "rmi://" + RemoteHost ;

    try {
      String[] Bindings = Naming.list(RemoteURL) ;
      for (int i= 0; i<Bindings.length; ++i) {
	System.out.println(Bindings[i]) ;
	try {
	  RemoteObject ro = (RemoteObject)Naming.lookup(Bindings[i]) ;
	  printRemoteObject(ro.toString()) ;
	}
	catch (NotBoundException e) {
	  System.out.println("  **Not bound**") ;
	}
	catch (AccessException e) {
	  System.out.println("  **Access exception** " + e.getMessage()) ;
	}
	catch (RemoteException e) {
	  Throwable t = e.detail ;
	  if (t instanceof ClassNotFoundException)
	    System.out.println("  " + t.getMessage() +
			       " -- class not found" ) ;
	  else
	    System.out.println("  **Remote exception**  " + e.getMessage()) ;
	}
      }
    }
    catch (MalformedURLException e) {
      System.out.println("Bad URL:" + e) ;
    }
    catch (java.rmi.ConnectException e) {
      System.out.println("Can't connect to " + RemoteURL) ;
    }
    catch (RemoteException e) {
      System.out.println("Failure to " + RemoteURL + ": " + e) ;
    }
  }
}
